<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JMap.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JMap.java</span></div><h1>JMap.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

/**
 *
 */
public class JMap extends JCompType {
   
<span class="nc" id="L26">    static private int level = 0;</span>
    
<span class="nc" id="L28">    static private String getLevel() { return Integer.toString(level); }</span>
    
<span class="nc" id="L30">    static private void incrLevel() { level++; }</span>
    
<span class="nc" id="L32">    static private void decrLevel() { level--; }</span>
    
<span class="nc" id="L34">    static private String getId(String id) { return id+getLevel(); }</span>
    
    private JType mKey;
    private JType mValue;
    
    /** Creates a new instance of JMap */
    public JMap(JType t1, JType t2) {
<span class="nc" id="L41">        super(&quot;#error&quot;, &quot; ::std::map&lt;&quot;+t1.getCppType()+&quot;,&quot;+t2.getCppType()+&quot;&gt;&quot;,</span>
                &quot;System.Collections.Generic.SortedDictionary&lt;string, string&gt;&quot;, &quot;java.util.TreeMap&quot;, &quot;Map&quot;, &quot;System.Collections.Generic.SortedDictionary&lt;string, string&gt;&quot;, &quot;java.util.TreeMap&quot;);
<span class="nc" id="L43">        mKey = t1;</span>
<span class="nc" id="L44">        mValue = t2;</span>
<span class="nc" id="L45">    }</span>
    
    public String getSignature() {
<span class="nc" id="L48">        return &quot;{&quot; + mKey.getSignature() + mValue.getSignature() +&quot;}&quot;;</span>
    }
    
    public String genJavaCompareTo(String fname) {
<span class="nc" id="L52">        return &quot;    throw new UnsupportedOperationException(\&quot;comparing &quot;</span>
            + fname + &quot; is unimplemented\&quot;);\n&quot;;
    }
    
    public String genJavaReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L57">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L58" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L59">            ret.append(&quot;    java.util.TreeMap &quot;+fname+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L61">        ret.append(&quot;    {\n&quot;);</span>
<span class="nc" id="L62">        incrLevel();</span>
<span class="nc" id="L63">        ret.append(&quot;      org.apache.jute.Index &quot;+getId(&quot;midx&quot;)+&quot; = a_.startMap(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L64">        ret.append(&quot;      &quot;+fname+&quot;=new java.util.TreeMap();\n&quot;);</span>
<span class="nc" id="L65">        ret.append(&quot;      for (; !&quot;+getId(&quot;midx&quot;)+&quot;.done(); &quot;+getId(&quot;midx&quot;)+&quot;.incr()) {\n&quot;);</span>
<span class="nc" id="L66">        ret.append(mKey.genJavaReadWrapper(getId(&quot;k&quot;),getId(&quot;k&quot;),true));</span>
<span class="nc" id="L67">        ret.append(mValue.genJavaReadWrapper(getId(&quot;v&quot;),getId(&quot;v&quot;),true));</span>
<span class="nc" id="L68">        ret.append(&quot;        &quot;+fname+&quot;.put(&quot;+getId(&quot;k&quot;)+&quot;,&quot;+getId(&quot;v&quot;)+&quot;);\n&quot;);</span>
<span class="nc" id="L69">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L70">        ret.append(&quot;    a_.endMap(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L71">        decrLevel();</span>
<span class="nc" id="L72">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L73">        return ret.toString();</span>
    }
    
    public String genJavaReadMethod(String fname, String tag) {
<span class="nc" id="L77">        return genJavaReadWrapper(fname, tag, false);</span>
    }
    
    public String genJavaWriteWrapper(String fname, String tag) {
<span class="nc" id="L81">        StringBuilder ret = new StringBuilder(&quot;    {\n&quot;);</span>
<span class="nc" id="L82">        incrLevel();</span>
<span class="nc" id="L83">        ret.append(&quot;      a_.startMap(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L84">        ret.append(&quot;      java.util.Set &quot;+getId(&quot;es&quot;)+&quot; = &quot;+fname+&quot;.entrySet();\n&quot;);</span>
<span class="nc" id="L85">        ret.append(&quot;      for(java.util.Iterator &quot;+getId(&quot;midx&quot;)+&quot; = &quot;+getId(&quot;es&quot;)+&quot;.iterator(); &quot;+getId(&quot;midx&quot;)+&quot;.hasNext(); ) {\n&quot;);</span>
<span class="nc" id="L86">        ret.append(&quot;        java.util.Map.Entry &quot;+getId(&quot;me&quot;)+&quot; = (java.util.Map.Entry) &quot;+getId(&quot;midx&quot;)+&quot;.next();\n&quot;);</span>
<span class="nc" id="L87">        ret.append(&quot;        &quot;+mKey.getJavaWrapperType()+&quot; &quot;+getId(&quot;k&quot;)+&quot; = (&quot;+mKey.getJavaWrapperType()+&quot;) &quot;+getId(&quot;me&quot;)+&quot;.getKey();\n&quot;);</span>
<span class="nc" id="L88">        ret.append(&quot;        &quot;+mValue.getJavaWrapperType()+&quot; &quot;+getId(&quot;v&quot;)+&quot; = (&quot;+mValue.getJavaWrapperType()+&quot;) &quot;+getId(&quot;me&quot;)+&quot;.getValue();\n&quot;);</span>
<span class="nc" id="L89">        ret.append(mKey.genJavaWriteWrapper(getId(&quot;k&quot;),getId(&quot;k&quot;)));</span>
<span class="nc" id="L90">        ret.append(mValue.genJavaWriteWrapper(getId(&quot;v&quot;),getId(&quot;v&quot;)));</span>
<span class="nc" id="L91">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L92">        ret.append(&quot;      a_.endMap(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L93">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L94">        decrLevel();</span>
<span class="nc" id="L95">        return ret.toString();</span>
    }
    
    public String genJavaWriteMethod(String fname, String tag) {
<span class="nc" id="L99">        return genJavaWriteWrapper(fname, tag);</span>
    }

    public String genCsharpWriteWrapper(String fname, int tag) {
<span class="nc" id="L103">        StringBuilder ret = new StringBuilder(&quot;    {\n&quot;);</span>
<span class="nc" id="L104">        incrLevel();</span>
<span class="nc" id="L105">        ret.append(&quot;      a_.StartMap(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L106">        ret.append(&quot;      java.util.Set &quot;+getId(&quot;es&quot;)+&quot; = &quot;+fname+&quot;.entrySet();\n&quot;);</span>
<span class="nc" id="L107">        ret.append(&quot;      for(java.util.Iterator &quot;+getId(&quot;midx&quot;)+&quot; = &quot;+getId(&quot;es&quot;)+&quot;.iterator(); &quot;+getId(&quot;midx&quot;)+&quot;.hasNext(); ) {\n&quot;);</span>
<span class="nc" id="L108">        ret.append(&quot;        java.util.Map.Entry &quot;+getId(&quot;me&quot;)+&quot; = (java.util.Map.Entry) &quot;+getId(&quot;midx&quot;)+&quot;.next();\n&quot;);</span>
<span class="nc" id="L109">        ret.append(&quot;        &quot;+mKey.getCsharpWrapperType()+&quot; &quot;+getId(&quot;k&quot;)+&quot; = (&quot;+mKey.getCsharpWrapperType()+&quot;) &quot;+getId(&quot;me&quot;)+&quot;.getKey();\n&quot;);</span>
<span class="nc" id="L110">        ret.append(&quot;        &quot;+mValue.getCsharpWrapperType()+&quot; &quot;+getId(&quot;v&quot;)+&quot; = (&quot;+mValue.getCsharpWrapperType()+&quot;) &quot;+getId(&quot;me&quot;)+&quot;.getValue();\n&quot;);</span>
<span class="nc" id="L111">        ret.append(mKey.genCsharpWriteWrapper(getId(&quot;k&quot;),getId(&quot;k&quot;)));</span>
<span class="nc" id="L112">        ret.append(mValue.genCsharpWriteWrapper(getId(&quot;v&quot;),getId(&quot;v&quot;)));</span>
<span class="nc" id="L113">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L114">        ret.append(&quot;      a_.EndMap(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L115">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L116">        decrLevel();</span>
<span class="nc" id="L117">        return ret.toString();</span>
    }

    String genCsharpWriteMethod(String fname, int tag) {
<span class="nc" id="L121">        return genCsharpWriteWrapper(fname, tag);</span>
    }

    public String genCsharpReadWrapper(String fname, int tag, boolean decl) {
<span class="nc" id="L125">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L126" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L127">            ret.append(&quot;    System.Collections.SortedDictionary&lt;string,string&gt; &quot;+capitalize(fname)+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L129">        ret.append(&quot;    {\n&quot;);</span>
<span class="nc" id="L130">        incrLevel();</span>
<span class="nc" id="L131">        ret.append(&quot;      Org.Apache.Jute.IIndex &quot;+getId(&quot;midx&quot;)+&quot; = a_.StartMap(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L132">        ret.append(&quot;      &quot;+fname+&quot;= new System.Collections.SortedDictionary&lt;string,string&gt;();\n&quot;);</span>
<span class="nc" id="L133">        ret.append(&quot;      for (; !&quot;+getId(&quot;midx&quot;)+&quot;.done(); &quot;+getId(&quot;midx&quot;)+&quot;.incr()) {\n&quot;);</span>
<span class="nc" id="L134">        ret.append(mKey.genCsharpReadWrapper(getId(&quot;k&quot;),getId(&quot;k&quot;),true));</span>
<span class="nc" id="L135">        ret.append(mValue.genCsharpReadWrapper(getId(&quot;v&quot;),getId(&quot;v&quot;),true));</span>
<span class="nc" id="L136">        ret.append(&quot;        &quot;+fname+&quot;.Add(&quot;+getId(&quot;k&quot;)+&quot;,&quot;+getId(&quot;v&quot;)+&quot;);\n&quot;);</span>
<span class="nc" id="L137">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L138">        ret.append(&quot;    a_.EndMap(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L139">        decrLevel();</span>
<span class="nc" id="L140">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L141">        return ret.toString();</span>
    }



    String genCsharpReadMethod(String fname, int tag) {
<span class="nc" id="L147">        return genCsharpReadWrapper(fname, tag, false);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>